<?php
  header("pragma: no-cache");
  header("cache-control: no-cache");
  header("expires: ".GMDate("D, d m Y H:i:s")." GMT");

  define('IN_MNews', true);
  
  
  session_start();
  @include_once './data/databases/mn-db-config.php';
  include_once './stuff/inc/mn-functions.php';
  $lng = select_lang();
  include_once './stuff/lang/lang_'.$lng.'.php';
  include_once './stuff/inc/mn-definitions.php';
  

  if (!isset($_SESSION["mn_lang"])) {
    $tmpl['lang_select'] = true;
  }





  elseif ($_GET["step"] == 1) {
    if (is_writeable('./data/') && is_writeable('./data/news/') && is_writeable('./data/articles/') && is_writeable('./data/templates/') && is_writeable('./data/databases/')) {
      header("location: ./mn-install.php?step=2");
      exit;
    }
    else {
      $info['main'] = $lang['inst_mnews_install'] . " - " . $lang['inst_change_chmod'];
      $tmpl['manual_chmod'] = true;
    }
  }





  elseif ($_GET["step"] == 2) {
    if (!is_writeable('./data/') || !is_writeable('./data/news/') || !is_writeable('./data/articles/') || !is_writeable('./data/templates/') || !is_writeable('./data/databases/')) {
      header("location: ./mn-install.php?step=1");
      exit;
    }
    else{
      if (!file_exists("./".$file['config'])) {
        $url_path = "http://".$_SERVER['SERVER_NAME'].$_SERVER["PHP_SELF"];
        $url_path = preg_replace( "/\mn-install\.php/is", "", $url_path);
        if (substr($url_path, -1) == "/") $url_path = substr($url_path, 0, -1);
        $config_content = "<?php\n\n\t\$conf['mnews_url_path'] = '$url_path';\n\t\$conf['page_encoding'] = 'utf-8';\n\t\$conf['lang'] = '".$_SESSION["mn_lang"]."';\n\t\$conf['wysiwyg'] = 'simple';\n\t\$conf['news_count'] = 10;\n\t\$conf['pagination_break'] = 10;\n\t\$conf['show_pagination'] = true;\n\n?".">";

        $config_file = fopen("./".$file['config'], "w");
        fwrite($config_file, $config_content);
        fclose($config_file);
      }
      
      if (!file_exists("./".$file['main_tmpl'])) {
        $tmpl_main = fopen("./".$file['main_tmpl'], "w");
        fwrite($tmpl_main, $def['default_main_tmpl']);
        fclose($tmpl_main);
      }
      
      if (!file_exists("./".$file['category_tmpl'])) {
        $tmpl_cat = fopen("./".$file['category_tmpl'], "w");
        fwrite($tmpl_cat, $def['default_category_tmpl']);
        fclose($tmpl_cat);
      }
      
      if (!file_exists("./".$file['pagination_tmpl'])) {
        $tmpl_pagination = fopen("./".$file['pagination_tmpl'], "w");
        fwrite($tmpl_pagination, $def['default_pagination_tmpl']);
        fclose($tmpl_pagination);
      }
      
      if (!file_exists("./".$file['article_tmpl'])) {
        $tmpl_article = fopen("./".$file['article_tmpl'], "w");
        fwrite($tmpl_article, $def['default_article_tmpl']);
        fclose($tmpl_article);
      }
    }
    
    $info['main'] = $lang['inst_mnews_install'] . " - " . $lang['inst_add_admin'];
    $tmpl['user_add'] = true;
  }





  elseif ($_POST["mode"] == "add_user") {

    if (!empty($_POST['user_login']) && !empty($_POST['user_mail']) && !empty($_POST['user_pass1']) && !empty($_POST['user_pass2'])) {
      if (check_email($_POST['user_mail'])) {
        if ($_POST['user_pass1'] == $_POST['user_pass2']) {
          $users_file_content = $def['safety_line']."|1\n";
          $users_file_content .= "1|".$_POST["user_login"]."|".sha1($_POST["user_pass1"])."|1|".time()."|".$_POST["user_mail"]."\n";
          $new_users_file = fopen("./".$file['users'], "w+");
          fwrite($new_users_file, $users_file_content);
          fclose($new_users_file);
          header("location: ./mn-install.php?&step=done");
          exit;
        }
        else {$info['red'] = $lang['users_back_pass2'];}
      }
      else {$info['red'] = $lang['users_back_email'];}
    }
    else {$info['red'] = $lang['users_back_empty'];}
    
    $echo['login'] = $_POST['user_login'];
    $echo['mail'] = $_POST['user_mail'];
    $echo['level'] = $_POST['user_level'];
    $tmpl['user_add'] = true;
    
  }





  elseif ($_GET["step"] == "done") {
    $info['main'] = $lang['inst_successfull'];
    $tmpl['inst_done'] = true;
  }






  else {
    if (is_writeable('./data/') && is_writeable('./data/news/') && is_writeable('./data/articles/') && is_writeable('./data/templates/') && is_writeable('./data/databases/')) {
      header("location: ./mn-install.php?step=2");
      exit;
    }
    else {
      @chmod('./data/', 0777);
      @chmod('./data/databases/', 0777);
      @chmod('./data/news/', 0777);
      @chmod('./data/templates/', 0777);
      @chmod('./data/articles/', 0777);
      if (is_writeable('./data/') && is_writeable('./data/news/') && is_writeable('./data/templates/') && is_writeable('./data/databases/') && is_writeable('./data/articles/')) {
        header("location: ./mn-install.php?step=2");
        exit;
      }
      else {
        header("location: ./mn-install.php?step=1");
        exit;
      }
    }
  }



  $echo['page_title'] = $lang['inst_mnews_install'];  

  include './stuff/tmpl/page-top.php';
  include './stuff/tmpl/feedback_info.php';


  if ($tmpl['user_add']) {
?>

  <p><?php echo $lang['inst_add_admin_text'];?></p>
  <form action='./mn-install.php' method='post' id='users-form'>
    <fieldset>
      <table>
        <tr><td width="40%" class="user-legend"><img src='./stuff/img/icons/user_gray.png' alt='user' /> <?php echo $lang['users_login'];?>:</td><td><input type='text' name='user_login' class='long' value='<?php echo htmlspecialchars($echo['login']);?>' /></td></tr>
        <tr class='users-help'><td colspan="2"><?php echo $lang['users_help_login'];?></td></tr>

        <tr><td class="user-legend"><img src='./stuff/img/icons/email.png' alt='user' /> <?php echo $lang['users_email'];?>:</td><td><input type='text' name='user_mail' class='long' value='<?php echo $echo['mail'];?>' /></td></tr>
        <tr class='users-help'><td colspan="2"><?php echo $lang['users_help_mail'];?></td></tr>

        <tr><td class="user-legend"><img src='./stuff/img/icons/key.png' alt='user' /> <?php echo $lang['users_pass1'];?>:</td><td><input type='password' name='user_pass1' class='long' value='' /></td></tr>
        <tr class='users-help'><td colspan="2"><?php echo $lang['users_help_pass1'];?></td></tr>

        <tr><td class="user-legend"><img src='./stuff/img/icons/key_go.png' alt='user' /> <?php echo $lang['users_pass2'];?>:</td><td><input type='password' name='user_pass2' class='long' value='' /></td></tr>
        <tr class='users-help'><td colspan="2"><?php echo $lang['users_help_pass2'];?></td></tr>
      </table>
      <p>
      <input type='hidden' name='mode' value='add_user' />
      <button type='submit' name='submit'><img src='./stuff/img/icons/user_add.png' alt='add' /> <?php echo $lang['users_add'];?></button>
      </p>
    </fieldset>
  </form>

<?php
  }
  if ($tmpl['manual_chmod']) {
?>

  <p><?php echo $lang['inst_change_chmod_text']."</p><p>".$lang['inst_change_chmod_text2'];?></p>
  <ul class="chmod-dirs">
    <li>/data/</li>
    <li>/data/articles/</li>
    <li>/data/databases/</li>
    <li>/data/news/</li>
    <li>/data/templates/</li>
  </ul>
  <div class='simbutton'><a href="./mn-install.php?step=2"><img src="./stuff/img/icons/continue.png" alt="continue" /> <?php echo $lang['gen_continue'];?></a></div>

  <p class="r"><span class="simurl" onclick="ShowHide('chmod-help-manual');"><img src="./stuff/img/icons/help.png" alt="help" /> <?php echo $lang['inst_show_chmod_manual'];?></span></p>
  <ol class="hide" id="chmod-help-manual">
    <li><?php echo $lang['inst_change_chmod_step1'];?></li>
    <li><?php echo $lang['inst_change_chmod_step2'];?></li>
    <li><?php echo $lang['inst_change_chmod_step3'];?></li>
    <li><?php echo $lang['inst_change_chmod_step4'];?></li>
    <li><?php echo $lang['inst_change_chmod_step5'];?></li>
  </ol>

<?php
  }
  if ($tmpl['inst_done']) echo "<p class='c'>".$lang['inst_successfull_text']." <a href='./'>index</a>.</p>";

  if ($tmpl['lang_select']) {
    echo "<ul id='install-lang'>";
    foreach ($languages as $lang_abbr => $lang_name) {
      echo "<li><a href='./mn-login.php?lang-select=$lang_abbr'><img src='./stuff/lang/lang_$lang_abbr.gif' alt='$lang_abbr' /> $lang_name</a></li>";
    }
    echo "</ul>";
  }
  
  include './stuff/tmpl/page-bottom.php';
?>
